/*
  xext ver 4.00
    (c)Junichi Akita (akita@fun.ac.jp)

  (ver1.00) using V4L2
  (ver1.10:2002.3.15) making LUT from object#5 to object #1
  (ver1.11:2002.3.23) using 2 markers (object#1 to object#6)
  (ver1.20:2002.4.09) show H&S plot, determine HSV range manually
  (ver1.21:2002.4.12) some bug fix
  (ver1.22:2002:4.14) some bug fix
  (ver2.14:2002.12.1) some bug fix
  (ver2.20:2003.3.04) modified for ccam-2.20
  (ver4.00:2003.4.15) adjusuted version number to ccam-4.00
 */

#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkprivate.h>
#include "ccam.h"
#include "cmvision.h"
#include "capture.h"

#include <stdio.h>
#include <sys/time.h>
#include <signal.h>
#include <math.h>

#define TCYCLE (50) /* time interval to capture [ms] */
#define NOBJ (100)  /* maximum number of target objects per color */

#define MAPX Y
#define MAPY Y

#define MAPCX (MAPX/2)
#define MAPCY (MAPY/2)

#define MAGX ((double)MAPX / 360.0)
#define MAGY ((double)MAPY)

//#define ADJ_UPDATE GTK_UPDATE_DELAYED // GTK_ADJ update timing
#define ADJ_UPDATE GTK_UPDATE_CONTINUOUS

#define iabs(a) ((a)>0?(a):(-(a)))

#define ARG_STEP 1.0

int *colr, *colg, *colb;
GtkWidget *area;
GdkImage *image;
GtkWidget *area2;
GdkImage *image2;
GtkWidget *label_info1;
GtkWidget *label_info2;
GdkRectangle update_rect;
GdkRectangle update_rect2;
GtkWidget *notebook;
GtkObject *adjhu1, *adjhl1, *adjsu1, *adjsl1, *adjvu1, *adjvl1;
GtkObject *adjhu2, *adjhl2, *adjsu2, *adjsl2, *adjvu2, *adjvl2;
GtkObject *adjhu3, *adjhl3, *adjsu3, *adjsl3, *adjvu3, *adjvl3;
GtkObject *adjhu4, *adjhl4, *adjsu4, *adjsl4, *adjvu4, *adjvl4;
GtkObject *adjhu5, *adjhl5, *adjsu5, *adjsl5, *adjvu5, *adjvl5;
GtkObject *adjhu6, *adjhl6, *adjsu6, *adjsl6, *adjvu6, *adjvl6;
GtkObject *adjhu7, *adjhl7, *adjsu7, *adjsl7, *adjvu7, *adjvl7;
int XS=0, XE=X, YS=0, YE=Y, XA=X, YA=Y;
int **xs, **ys, **xe, **ye;
int *no;
unsigned char f[OBJ_LUT_SIZE][OBJ_LUT_SIZE][OBJ_LUT_SIZE];
int selcol = CB;
int points = 0;
int apoint = 0;
int xs0, ys0, xe0, ye0;
int lstep = 0;
int go = 0;
int  BF_OFFSET_PER_LINE;
int  BF_OFFSET_INIT;
double hu[8], hl[8], su[8], sl[8], vu[8], vl[8];
double hu0[8], hl0[8], su0[8], sl0[8], vu0[8], vl0[6];
int type[8];
unsigned char *dbuf;
unsigned char *mapbuf;
unsigned char *mapbuf0;
capture cap;

void draw_color_map();
gint sethu1(GtkWidget *widget,GtkAdjustment *adj){hu[1]=adj->value;draw_color_map();return TRUE;}
gint sethl1(GtkWidget *widget,GtkAdjustment *adj){hl[1]=adj->value;draw_color_map();return TRUE;}
gint setsu1(GtkWidget *widget,GtkAdjustment *adj){su[1]=adj->value;draw_color_map();return TRUE;}
gint setsl1(GtkWidget *widget,GtkAdjustment *adj){sl[1]=adj->value;draw_color_map();return TRUE;}
gint setvu1(GtkWidget *widget,GtkAdjustment *adj){vu[1]=adj->value;draw_color_map();return TRUE;}
gint setvl1(GtkWidget *widget,GtkAdjustment *adj){vl[1]=adj->value;draw_color_map();return TRUE;}
gint sethu2(GtkWidget *widget,GtkAdjustment *adj){hu[2]=adj->value;draw_color_map();return TRUE;}
gint sethl2(GtkWidget *widget,GtkAdjustment *adj){hl[2]=adj->value;draw_color_map();return TRUE;}
gint setsu2(GtkWidget *widget,GtkAdjustment *adj){su[2]=adj->value;draw_color_map();return TRUE;}
gint setsl2(GtkWidget *widget,GtkAdjustment *adj){sl[2]=adj->value;draw_color_map();return TRUE;}
gint setvu2(GtkWidget *widget,GtkAdjustment *adj){vu[2]=adj->value;draw_color_map();return TRUE;}
gint setvl2(GtkWidget *widget,GtkAdjustment *adj){vl[2]=adj->value;draw_color_map();return TRUE;}
gint sethu3(GtkWidget *widget,GtkAdjustment *adj){hu[3]=adj->value;draw_color_map();return TRUE;}
gint sethl3(GtkWidget *widget,GtkAdjustment *adj){hl[3]=adj->value;draw_color_map();return TRUE;}
gint setsu3(GtkWidget *widget,GtkAdjustment *adj){su[3]=adj->value;draw_color_map();return TRUE;}
gint setsl3(GtkWidget *widget,GtkAdjustment *adj){sl[3]=adj->value;draw_color_map();return TRUE;}
gint setvu3(GtkWidget *widget,GtkAdjustment *adj){vu[3]=adj->value;draw_color_map();return TRUE;}
gint setvl3(GtkWidget *widget,GtkAdjustment *adj){vl[3]=adj->value;draw_color_map();return TRUE;}
gint sethu4(GtkWidget *widget,GtkAdjustment *adj){hu[4]=adj->value;draw_color_map();return TRUE;}
gint sethl4(GtkWidget *widget,GtkAdjustment *adj){hl[4]=adj->value;draw_color_map();return TRUE;}
gint setsu4(GtkWidget *widget,GtkAdjustment *adj){su[4]=adj->value;draw_color_map();return TRUE;}
gint setsl4(GtkWidget *widget,GtkAdjustment *adj){sl[4]=adj->value;draw_color_map();return TRUE;}
gint setvu4(GtkWidget *widget,GtkAdjustment *adj){vu[4]=adj->value;draw_color_map();return TRUE;}
gint setvl4(GtkWidget *widget,GtkAdjustment *adj){vl[4]=adj->value;draw_color_map();return TRUE;}
gint sethu5(GtkWidget *widget,GtkAdjustment *adj){hu[5]=adj->value;draw_color_map();return TRUE;}
gint sethl5(GtkWidget *widget,GtkAdjustment *adj){hl[5]=adj->value;draw_color_map();return TRUE;}
gint setsu5(GtkWidget *widget,GtkAdjustment *adj){su[5]=adj->value;draw_color_map();return TRUE;}
gint setsl5(GtkWidget *widget,GtkAdjustment *adj){sl[5]=adj->value;draw_color_map();return TRUE;}
gint setvu5(GtkWidget *widget,GtkAdjustment *adj){vu[5]=adj->value;draw_color_map();return TRUE;}
gint setvl5(GtkWidget *widget,GtkAdjustment *adj){vl[5]=adj->value;draw_color_map();return TRUE;}

gint sethu6(GtkWidget *widget,GtkAdjustment *adj){hu[6]=adj->value;draw_color_map();return TRUE;}
gint sethl6(GtkWidget *widget,GtkAdjustment *adj){hl[6]=adj->value;draw_color_map();return TRUE;}
gint setsu6(GtkWidget *widget,GtkAdjustment *adj){su[6]=adj->value;draw_color_map();return TRUE;}
gint setsl6(GtkWidget *widget,GtkAdjustment *adj){sl[6]=adj->value;draw_color_map();return TRUE;}
gint setvu6(GtkWidget *widget,GtkAdjustment *adj){vu[6]=adj->value;draw_color_map();return TRUE;}
gint setvl6(GtkWidget *widget,GtkAdjustment *adj){vl[6]=adj->value;draw_color_map();return TRUE;}
gint sethu7(GtkWidget *widget,GtkAdjustment *adj){hu[7]=adj->value;draw_color_map();return TRUE;}
gint sethl7(GtkWidget *widget,GtkAdjustment *adj){hl[7]=adj->value;draw_color_map();return TRUE;}
gint setsu7(GtkWidget *widget,GtkAdjustment *adj){su[7]=adj->value;draw_color_map();return TRUE;}
gint setsl7(GtkWidget *widget,GtkAdjustment *adj){sl[7]=adj->value;draw_color_map();return TRUE;}
gint setvu7(GtkWidget *widget,GtkAdjustment *adj){vu[7]=adj->value;draw_color_map();return TRUE;}
gint setvl7(GtkWidget *widget,GtkAdjustment *adj){vl[7]=adj->value;draw_color_map();return TRUE;}

#define NUM_COLOR 7

colors get_rgb(unsigned char *bf, colors col)
{
  unsigned char p1, p2;
  p1 = *(bf+1); p2 = *bf;
  col.r = (p1 & 0xf8);
  col.g = ((p1 & 0x07) << 5) | ((p2 & 0xe0) >> 3);
  col.b = (p2 & 0x1f) << 3;
  return(col);
}

unsigned char *set_rgb(unsigned char *bf, colors col)
{
  *bf = ((col.g & 0x1c) << 3) | (col.b >> 3); 
  *(bf+1) = (col.r & 0xf8) | (col.g >> 5);
  return(bf);
}

unsigned char *set_buf(int x, int y)
{
  return(dbuf + (y * X + x) * 2);
}

void map_pixel(int x, int y, int r, int g, int b)
{
  unsigned char *bf;

  bf = mapbuf + (y * MAPX + x) * 2;
  *bf = ((g & 0x1c) << 3) | (b >> 3); 
  *(bf+1) = (r & 0xf8) | (g >> 5);
}

void map0_pixel(int x, int y, int r, int g, int b)
{
  unsigned char *bf;

  bf = mapbuf0 + (y * MAPX + x) * 2;
  *bf = ((g & 0x1c) << 3) | (b >> 3); 
  *(bf+1) = (r & 0xf8) | (g >> 5);
}

void clear_color_map()
{
  int i;
  for (i = 0; i < MAPX*MAPY*3; i++) mapbuf0[i] = 0;
}

void map_line(int x1, int y1, int x2, int y2, int r, int g, int b)
{
  int i;
  double a;

  if (iabs(x1-x2) > iabs(y1-y2)){
    a = (double)(y1-y2)/(double)(x1-x2);
    if (x1 > x2)
      for (i = x2; i <= x1; i++) map_pixel(i,(int)(a*(double)(i-x2)+y2),r,g,b);
    else
      for (i = x1; i <= x2; i++) map_pixel(i,(int)(a*(double)(i-x2)+y2),r,g,b);
  }
  else{
    a = (double)(x1-x2)/(double)(y1-y2);
    if (y1 > y2)
      for (i = y2; i <= y1; i++) map_pixel((int)(a*(double)(i-y2)+x2),i,r,g,b);
    else
      for (i = y1; i <= y2; i++) map_pixel((int)(a*(double)(i-y2)+x2),i,r,g,b);
  }
}


void buf_cpy(image_pixel *img)
{
    int i, j;
    image_pixel p;
    j = 0;
    for (i = 0; i < X*Y; i++){
	p = img[i];
	dbuf[j++] = ((p.green & 0x1c) << 3) | (p.blue >> 3); 
	dbuf[j++] = (p.red & 0xf8) | (p.green >> 5);
    }
}

void map0_pixel_col(colors col)
{
  int x, y;
  x = MAPCX + (int)(MAPY/2 * col.s * cos((col.h)/180*3.14159));
  y = MAPCY - (int)(MAPY/2 * col.s * sin((col.h)/180*3.14159));
  map0_pixel(x, y, col.r, col.g, col.b);
}

void map_arc(int x0, int y0, double R, double ds, double de, int r, int g, int b)
{
  double d;
  int x, y;
  for (d = ds; d <= de; d += ARG_STEP){
    x = x0 + (int)(R * cos(d/180.0*3.14159));
    y = y0 - (int)(R * sin(d/180.0*3.14159));
    map_pixel(x, y, r, g, b);
  }
}

void draw_color_map()
{
  int x, y;
  colors col;
  double H, S;
  int i;
  int x1, y1, x2, y2;
  int x3, y3, x4, y4;

  for (x = 0; x < MAPX; x++)
    for (y = 0; y < MAPY; y++) map_pixel(x, y, 0, 0, 0);

  for (x = 0; x < MAPX*MAPY*3; x++) mapbuf[x] = mapbuf0[x];

  map_line(0, MAPCY, MAPX, MAPCY, 255, 255, 255);
  map_line(MAPCX, 0, MAPCX, MAPY, 255, 255, 255);
  map_arc(MAPCX, MAPCY, MAPY/2, 0, 360, 255, 255, 255);

  for (i = 1; i <= NUM_COLOR; i++){
    int r, g, b;
    if (hu[i] != hl[i] && su[i] != sl[i]){
      r = colr[i]; g = colg[i]; b = colb[i];
      if (type[i] == 0){
	x1 = MAPCX+(int)(MAPY/2 * sl[i] * cos((hu[i])/180*3.14159));
	y1 = MAPCY-(int)(MAPY/2 * sl[i] * sin((hu[i])/180*3.14159));
	x2 = MAPCX+(int)(MAPY/2 * su[i] * cos((hu[i])/180*3.14159));
	y2 = MAPCY-(int)(MAPY/2 * su[i] * sin((hu[i])/180*3.14159));
	map_line(x1, y1, x2, y2, r, g, b);
	x1 = MAPCX+(int)(MAPY/2 * sl[i] * cos((hl[i])/180*3.14159));
	y1 = MAPCY-(int)(MAPY/2 * sl[i] * sin((hl[i])/180*3.14159));
	x2 = MAPCX+(int)(MAPY/2 * su[i] * cos((hl[i])/180*3.14159));
	y2 = MAPCY-(int)(MAPY/2 * su[i] * sin((hl[i])/180*3.14159));
	map_line(x1, y1, x2, y2, r, g, b);
	
	map_arc(MAPCX, MAPCY, MAPY/2*sl[i], hl[i], hu[i], r, g, b);
	map_arc(MAPCX, MAPCY, MAPY/2*su[i], hl[i], hu[i], r, g, b);
      }
      else{
	x1 = (int)((hl[i] - H_ORIGIN) * MAGX);
	y1 = (int)((1.0-sl[i]) * MAGY);
	x2 = (int)((hu[i] - H_ORIGIN) * MAGX);
	y2 = (int)((1.0-sl[i]) * MAGY);
	x3 = (int)((hu[i] - H_ORIGIN) * MAGX);
	y3 = (int)((1.0-su[i]) * MAGY);
	x4 = (int)((hl[i] - H_ORIGIN) * MAGX);
	y4 = (int)((1.0-su[i]) * MAGY);
	if (hl[i] < hu[i] && sl[i] < su[i]){
	  map_line(x1, y1, x2, y2, r, g, b);
	  map_line(x2, y2, x3, y3, r, g, b);
	  map_line(x3, y3, x4, y4, r, g, b);
	  map_line(x4, y4, x1, y1, r, g, b);
	}
      }
    }
  }
  gtk_widget_draw(area2, &update_rect2);
}

gint timer_call()
{
    int i, j, x, y;
    char ss[1024];
    int r, g, b;
    unsigned char *bf;
    int r0, g0, b0;
    int n1;
    FILE *fp;
    colors col;
    image_pixel p, *img;
    double h0, s0, v0;

    if (go == 1){
	img = (image_pixel*)cap.captureFrame();
	buf_cpy(img);
	for (i = 1; i <= NUM_COLOR; i++){
	  for (j = 0; j < no[i]; j++){
	    h0 = 0.0; s0 = 0.0; v0 = 0.0;
	    for (y = ys[i][j]+1; y < ye[i][j]; y++){
	      for (x = xs[i][j]+1; x < xe[i][j]; x++){
		p = img[(x + y*X)];
		r0 = p.red; g0 = p.green; b0 = p.blue;
		col.r = r0; col.g = g0; col.b = b0;
		col = calc_color(col);
		if ((col.v <= vu[i]) && (col.v >= vl[i])){
		  map0_pixel_col(col);
		  col.r = colr[i]; col.g = colg[i]; col.b = colb[i];
		  set_rgb(dbuf + (y * X + x) * 2, col);
		}
	      }
	    }
	  }
	}
	draw_color_map();
	gtk_widget_draw(area, &update_rect);
	gtk_widget_draw(area2, &update_rect2);

	sprintf(ss, "Color Map Plotting...");
	gtk_label_set(GTK_LABEL(label_info1), ss);
	sprintf(ss, "#%d", lstep); lstep++;
	gtk_label_set(GTK_LABEL(label_info2), ss);
    }
    return(TRUE);
}

gint BNredraw(GtkWidget *widget)
{
  image_pixel *img;
  img = (image_pixel*)cap.captureFrame();
  buf_cpy(img);
  gtk_widget_draw(area, &update_rect);
  gtk_widget_draw(area2, &update_rect2);
  return TRUE;
}

gboolean EXdraw_image(GtkWidget *widget)
{
    gdk_draw_image(widget->window, widget->style->fg_gc[GTK_STATE_NORMAL],
		   image, 0, 0, 0, 0, X, Y);
    return(TRUE);
}

gboolean EXdraw_image2(GtkWidget *widget)
{
    gdk_draw_image(widget->window, widget->style->fg_gc[GTK_STATE_NORMAL],
		   image2, 0, 0, 0, 0, MAPX, MAPY);
    return(TRUE);
}

gint BNquit(GtkWidget *widget)
{
    cap.close();
    gtk_main_quit();
}

gint MObutton(GtkWidget *widget, GdkEventButton *event)
{
    int x, y;
    int t;
    unsigned char *bf;
    colors col;

    x = (int)event->x;
    y = (int)event->y;
    if (event->button == 1){
	/* left button */
	if (points == 0){
	    xs[selcol][no[selcol]] = x;
	    ys[selcol][no[selcol]] = y;
	    col.r = colr[selcol]; col.g = colg[selcol]; col.b = colb[selcol];
	    set_rgb(dbuf + BF_OFFSET_INIT, col);
	    gtk_widget_draw(area, &update_rect);
	    gtk_widget_draw(area2, &update_rect2);
	    points = 1;
	}
	else{
	    xe[selcol][no[selcol]] = x;
	    ye[selcol][no[selcol]] = y;
	    if (xs[selcol][no[selcol]] > xe[selcol][no[selcol]]){
		t = xs[selcol][no[selcol]];
		xs[selcol][no[selcol]] = xe[selcol][no[selcol]];
		xe[selcol][no[selcol]] = t;
	    }
	    if (ys[selcol][no[selcol]] > ye[selcol][no[selcol]]){
		t = ys[selcol][no[selcol]];
		ys[selcol][no[selcol]] = ye[selcol][no[selcol]];
		ye[selcol][no[selcol]] = t;
	    }
	    col.r = colr[selcol]; col.g = colg[selcol]; col.b = colb[selcol];
	    bf = set_buf(xs[selcol][no[selcol]], ys[selcol][no[selcol]]);
	    for (y = ys[selcol][no[selcol]]; y < ye[selcol][no[selcol]]; y++){
		set_rgb(bf, col);  bf += X*2;
	    }
	    bf = set_buf(xe[selcol][no[selcol]], ys[selcol][no[selcol]]);
	    for (y = ys[selcol][no[selcol]]; y < ye[selcol][no[selcol]]; y++){
		set_rgb(bf, col); bf += X*2;
	    }
	    bf = set_buf(xs[selcol][no[selcol]], ys[selcol][no[selcol]]);
	    for (x = xs[selcol][no[selcol]]; x < xe[selcol][no[selcol]]; x++){
		set_rgb(bf, col); bf += 2;
	    }
	    bf = set_buf(xs[selcol][no[selcol]], ye[selcol][no[selcol]]);
	    for (x = xs[selcol][no[selcol]]; x < xe[selcol][no[selcol]]; x++){
		set_rgb(bf, col); bf += 2;
	    }
	    gtk_widget_draw(area, &update_rect);
	    gtk_widget_draw(area2, &update_rect2);
	    points = 0;
	    no[selcol]++;
	}
    }
    if (event->button == 3){
	/* right button */
	if (apoint == 0){
	    xs0 = x; ys0 = y;
	    apoint = 1;
	}
	else{
	    xe0 = x; ye0 = y;
	    if (xs0 > xe0){ t = xs0; xs0 = xe0; xe0 = t; }
	    if (ys0 > ye0){ t = ys0; ys0 = ye0; ye0 = t; }
	    XS = xs0; YS = ys0;
	    XE = xe0; YE = ye0;
	    BF_OFFSET_PER_LINE = (((X - XE) + XS) * 3);
	    if (YS > 0) BF_OFFSET_INIT = (((YS-1)*X) + XS) * 3;
	    else BF_OFFSET_INIT = XS * 3;
	    col.r = 0x1f; col.g = 0x3f; col.b = 0x1f;
	    bf = set_buf(XS, YS);
	    for (y = YS; y < YE; y++){ set_rgb(bf, col);  bf += X*2; }
	    bf = set_buf(XE, YS);
	    for (y = YS; y < YE; y++){ set_rgb(bf, col); bf += X*2; }
	    bf = set_buf(XS, YS);
	    for (x = XS; x < XE; x++){ set_rgb(bf, col); bf += 2; }
	    bf = set_buf(XS, YE);
	    for (x = XS; x < XE; x++){ set_rgb(bf, col); bf += 2; }
	    gtk_widget_draw(area, &update_rect);
	    gtk_widget_draw(area2, &update_rect2);
	    apoint = 0;
	}
    }
    return(0);
}

gint MOmoved(GtkWidget * widget, GdkEventMotion * event)
{
    int x, y;
    GdkModifierType state;
    char ss[1024];
    colors col;
    char target[1024];

    x = (int)event->x;
    y = (int)event->y;
    if (x >= XS && x <= XE && y >= YS && y <= YE){
	if (selcol == CB) strcpy(target, "Ball");
	if (selcol == CYM)  strcpy(target, "Y-Marker");
	if (selcol == CYM1) strcpy(target, "Y-Marker1");
	if (selcol == CYM2) strcpy(target, "Y-Marker2");
	if (selcol == CBM)  strcpy(target, "B-Marker");
	if (selcol == CBM1) strcpy(target, "B-Marker1");
	if (selcol == CBM2) strcpy(target, "B-Marker2");

	col = get_rgb(set_buf(x, y), col);
	col = calc_color(col);
	sprintf(ss, "target:%s[#%d] / [%d %d]-[%d %d]",
		target, no[selcol], XS, YS, XE, YE);
	gtk_label_set(GTK_LABEL(label_info1), ss);
	sprintf(ss, "(%d %d) RGB(%.3f/%.3f/%.3f) HSV(%.2f/%.4f/%.4f)",
		x, y, 
		(double)col.r/(double)0xf8,
		(double)col.g/(double)0xfc,
		(double)col.b/(double)0xf8,
		col.h, col.s, col.v);
	gtk_label_set(GTK_LABEL(label_info2), ss);
    }
    return TRUE;
}

gint BNsave_color_OK(GtkWidget *widget, GtkFileSelection *fs)
{
    char name[1024];
    FILE *fp;
    int r, g, b;
    int i;
    colors col;

    for (r = 0; r < OBJ_LUT_SIZE; r++){
      for (g = 0; g < OBJ_LUT_SIZE; g++){
	for (b = 0; b < OBJ_LUT_SIZE; b++){
	  f[r][g][b] = 0;
	  for (i = 1; i <= NUM_COLOR; i++){ 
	    col.r = r*DIV; col.g = g*DIV; col.b = b*DIV;
	    col = calc_color(col);
	    if (type[i] == 0){
	      if (col.h >= hl[i] && col.h <= hu[i]
		  && col.s >= sl[i] && col.s <= su[i]
		  && col.v >= vl[i] && col.v <= vu[i]){
		f[r][g][b] |= 1 << (i-1);
	      }
	    }
	    else{
	      double x, y;
	      double x1, x2, y1, y2;
	      x = MAPCX + (double)MAPY/2 * col.s * cos((col.h)/180.0*3.14159);
	      y = MAPCY - (double)MAPY/2 * col.s * sin((col.h)/180.0*3.14159);
	      x1 = (hl[i] - H_ORIGIN) * MAGX; y1 = (1.0-su[i]) * MAGY;
	      x2 = (hu[i] - H_ORIGIN) * MAGX; y2 = (1.0-sl[i]) * MAGY;
	      if (x >= x1 && x <= x2 && y >= y1 && y <= y2){
		f[r][g][b] |= 1 << (i-1);
	      }
	    }
	  }
	  /*
	  if (((f[r][g][b] & 0x20) != 0) && f[r][g][b] != 0x20)
	    printf("%02x\n", f[r][g][b]);
	  */
	}
      }
    }
    strcpy(name, gtk_file_selection_get_filename(fs));
    gtk_widget_destroy(GTK_WIDGET(fs));
   
    if ((fp = fopen(name, "wb")) == NULL){
	g_print("can't open %s\n", name);
    }

    for (r = 0; r < OBJ_LUT_SIZE; r++){
      for (g = 0; g < OBJ_LUT_SIZE; g++){
	for (b = 0; b < OBJ_LUT_SIZE; b++){
	  fprintf(fp, "%c", f[r][g][b]);
	}
      }
    }
    fclose(fp);

    strcat(name, ".bound");
    fp = fopen(name, "w");
    for (i = 1; i <= NUM_COLOR; i++){
      fprintf(fp, "%f %f %f %f %f %f %d\n",
	      hu[i],hl[i],su[i],sl[i],vu[i],vl[i],type[i]);
    }
    fclose(fp);
    return TRUE;
}

gint BNsave_color(GtkWidget *widget)
{
    GtkWidget *fs;
    fs = gtk_file_selection_new("save_color_as");
    gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(fs)->ok_button),
		       "clicked", GTK_SIGNAL_FUNC(BNsave_color_OK), fs);
    gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(fs)->cancel_button),
			      "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy),
			      GTK_OBJECT(fs));
    gtk_widget_show(fs);
    return TRUE;
}

gint BNclear(GtkWidget *widget)
{
    int r, g, b;
    int i;
    image_pixel *img;

    for (i = 0; i <= NUM_COLOR; i++){
      hu[i] = hu0[i]; hl[i] = hl0[i];
      su[i] = su0[i]; sl[i] = sl0[i];
      vu[i] = vu0[i]; vl[i] = vl0[i];
      type[i] = 0;
    }
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjhu1), hu[1]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjhl1), hl[1]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjsu1), su[1]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjsl1), sl[1]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjvu1), vu[1]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjvl1), vl[1]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjhu2), hu[2]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjhl2), hl[2]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjsu2), su[2]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjsl2), sl[2]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjvu2), vu[2]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjvl2), vl[2]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjhu3), hu[3]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjhl3), hl[3]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjsu3), su[3]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjsl3), sl[3]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjvu3), vu[3]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjvl3), vl[3]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjhu4), hu[4]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjhl4), hl[4]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjsu4), su[4]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjsl4), sl[4]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjvu4), vu[4]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjvl4), vl[4]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjhu5), hu[5]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjhl5), hl[5]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjsu5), su[5]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjsl5), sl[5]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjvu5), vu[5]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjvl5), vl[5]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjhu6), hu[6]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjhl6), hl[6]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjsu6), su[6]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjsl6), sl[6]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjvu6), vu[6]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjvl6), vl[6]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjhu7), hu[7]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjhl7), hl[7]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjsu7), su[7]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjsl7), sl[7]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjvu7), vu[7]);
    gtk_adjustment_set_value(GTK_ADJUSTMENT(adjvl7), vl[7]);

    points = 0;
    for (i = 0; i <= NUM_COLOR; i++) no[i] = 0;
    lstep = 0;

    clear_color_map();
    draw_color_map();

    img = (image_pixel*)cap.captureFrame();
    buf_cpy(img);

    gtk_widget_draw(area, &update_rect);
    gtk_widget_draw(area2, &update_rect2);
    return TRUE;
}

gint BNstart(GtkWidget *widget)
{
    image_pixel *img;
    img = (image_pixel*)cap.captureFrame();
    buf_cpy(img);
    go = 1;
    return TRUE;
}

gint BNstop(GtkWidget *widget)
{
    image_pixel *img;
    go = 0;
    img = (image_pixel*)cap.captureFrame();
    buf_cpy(img);
    gtk_widget_draw(area, &update_rect);
    gtk_widget_draw(area2, &update_rect2);
    return TRUE;
}

gint BNview(GtkWidget *widget)
{
    int i, j, x, y;
    colors col;
    image_pixel *img;

    img = (image_pixel*)cap.captureFrame();
    buf_cpy(img);

    for (i = 1; i <= NUM_COLOR; i++){
	for (j = 0; j < no[i]; j++){
	    for (x = xs[i][j]; x <= xe[i][j]; x++){
		for (y = ys[i][j]; y <= ye[i][j]; y++){
		    col = get_rgb(set_buf(x, y), col);
		    col = calc_color(col);
		    if ((col.v <= vu[i]) && (col.v >= vl[i])){
		      // col.r = colr[i]; col.g = colg[i]; col.b = colb[i];
			col.r = 0; col.g = 0; col.b = 0;
			set_rgb(set_buf(x, y), col);
		    }
		}
	    }
	}
    }
    gtk_widget_draw(area, &update_rect);
    gtk_widget_draw(area2, &update_rect2);
    return TRUE;
}

gint BNextract(GtkWidget *widget)
{
    int i, j, x, y;
    unsigned char *bf;
    int f0;
    int r0, g0, b0;
    int n;
    colors col;
    image_pixel p, *img;

    img = (image_pixel*)cap.captureFrame();
    buf_cpy(img);

    for (i = 1; i <= NUM_COLOR; i++){
      for (j = 0; j < no[i]; j++){
	n = 0;
	for (x = xs[i][j]; x <= xe[i][j]; x++){
	  for (y = ys[i][j]; y <= ye[i][j]; y++){
	    p = img[(x+y*X)];
	    r0 = p.red; g0 = p.green; b0 = p.blue;
	    col.r = r0; col.g = g0; col.b = b0;
	    col = calc_color(col);
	    col.r = 0; col.g = 0; col.b = 0;
	    if (type[i] == 0){
	      if (col.h >= hl[i] && col.h <= hu[i]
		  && col.s >= sl[i] && col.s <= su[i]
		  && col.v >= vl[i] && col.v <= vu[i]){
		col.r = colr[i]; col.g = colg[i]; col.b = colb[i];
	      }
	    }
	    else{
	      double x, y;
	      double x1, x2, y1, y2;
	      x = MAPCX + (double)MAPY/2 * col.s * cos((col.h)/180.0*3.14159);
	      y = MAPCY - (double)MAPY/2 * col.s * sin((col.h)/180.0*3.14159);
	      x1 = (hl[i] - H_ORIGIN) * MAGX; y1 = (1.0-su[i]) * MAGY;
	      x2 = (hu[i] - H_ORIGIN) * MAGX; y2 = (1.0-sl[i]) * MAGY;
	      if (x >= x1 && x <= x2 && y >= y1 && y <= y2){
		col.r = colr[i]; col.g = colg[i]; col.b = colb[i];
	
	      }
	    }
	    set_rgb(set_buf(x, y), col);
	  }
	}
      }
    }
    gtk_widget_draw(area, &update_rect);
    gtk_widget_draw(area2, &update_rect2);
    return TRUE;
}

gint BNextract_all(GtkWidget *widget)
{
    int i, j, x, y;
    unsigned char *bf;
    int f0;
    int r, g, b;
    int r0, g0, b0;
    int s;
    colors col;
    image_pixel p, *img;

    img = (image_pixel*)cap.captureFrame();
    buf_cpy(img);

    s = 0;
    for (x = XS; x < XE; x++){
      for (y = YS; y < YE; y++){
	p = img[(x+y*X)];
	r0 = p.red; g0 = p.green; b0 = p.blue;
	col.r = r0; col.g = g0; col.b = b0;
	col = calc_color(col);
	col.r = 0; col.g = 0; col.b = 0;
	for (i = 1; i <= NUM_COLOR; i++){
	  if (type[i] == 0){
	    if (col.h >= hl[i] && col.h <= hu[i]
		&& col.s >= sl[i] && col.s <= su[i]
		&& col.v >= vl[i] && col.v <= vu[i]){
	      col.r = colr[i]; col.g = colg[i]; col.b = colb[i];
	    }
	  }
	  else{
	    double x, y;
	    double x1, x2, y1, y2;
	    x = MAPCX + (double)MAPY/2 * col.s * cos((col.h)/180.0*3.14159);
	    y = MAPCY - (double)MAPY/2 * col.s * sin((col.h)/180.0*3.14159);
	    x1 = (hl[i] - H_ORIGIN) * MAGX; y1 = (1.0-su[i]) * MAGY;
	    x2 = (hu[i] - H_ORIGIN) * MAGX; y2 = (1.0-sl[i]) * MAGY;
	    if (x >= x1 && x <= x2 && y >= y1 && y <= y2){
	      col.r = colr[i]; col.g = colg[i]; col.b = colb[i];
	    }
	  }
	}
	set_rgb(set_buf(x, y), col);
      }
    }
    for (x = XS; x < XE; x++){
      for (y = YS; y < YE; y++){
	p = img[(x+y*X)];
	r0 = p.red; g0 = p.green; b0 = p.blue;
	col.r = r0; col.g = g0; col.b = b0;
	col = calc_color(col);
	col.r = 0; col.g = 0; col.b = 0;
      }
    }
    gtk_widget_draw(area, &update_rect);
    gtk_widget_draw(area2, &update_rect2);
    return TRUE;
}

gint BNconfirm(GtkWidget *widget)
{
    int i, j, x, y;
    int f0;
    colors col;
    unsigned char *bf;
    image_pixel *img;

    img = (image_pixel*)cap.captureFrame();
    buf_cpy(img);

    for (i = 1; i <= NUM_COLOR; i++){
	for (j = 0; j < no[i]; j++){
	    for (x = xs[i][j]; x <= xe[i][j]; x++){
		for (y = ys[i][j]; y <= ye[i][j]; y++){
		    col.r = colr[i]; col.g = colg[i]; col.b = colb[i];
		    bf = set_buf(xs[i][j], ys[i][j]);
		    for (y = ys[i][j]; y < ye[i][j]; y++){
			set_rgb(bf, col);  bf += X*2;
		    }
		    bf = set_buf(xe[i][j], ys[i][j]);
		    for (y = ys[i][j]; y < ye[i][j]; y++){
			set_rgb(bf, col); bf += X*2;
		    }
		    bf = set_buf(xs[i][j], ys[i][j]);
		    for (x = xs[i][j]; x < xe[i][j]; x++){
			set_rgb(bf, col); bf += 2;
		    }
		    bf = set_buf(xs[i][j], ye[i][j]);
		    for (x = xs[i][j]; x < xe[i][j]; x++){
			set_rgb(bf, col); bf += 2;
		    }
		}
	    }
	}
    }
    gtk_widget_draw(area, &update_rect);
    gtk_widget_draw(area2, &update_rect2);
    return TRUE;
}

void NBchange(GtkNotebook *notebook, GtkNotebookPage *page, gint pnum,
	      gpointer data)
{
  if (pnum == 0) selcol = CB;
  if (pnum == 1) selcol = CYM;
  if (pnum == 2) selcol = CBM;
  if (pnum == 3) selcol = CYM1;
  if (pnum == 4) selcol = CYM2;
  if (pnum == 5) selcol = CBM1;
  if (pnum == 6) selcol = CBM2;
  points = 0;
}    

void BNarc1(GtkButton *button, gpointer data){type[1] = 0; draw_color_map();}
void BNrect1(GtkButton *button, gpointer data){type[1] = 1;draw_color_map();}
void BNarc2(GtkButton *button, gpointer data){type[2] = 0; draw_color_map();}
void BNrect2(GtkButton *button, gpointer data){type[2] = 1;draw_color_map();}
void BNarc3(GtkButton *button, gpointer data){type[3] = 0; draw_color_map();}
void BNrect3(GtkButton *button, gpointer data){type[3] = 1;draw_color_map();}
void BNarc4(GtkButton *button, gpointer data){type[4] = 0; draw_color_map();}
void BNrect4(GtkButton *button, gpointer data){type[4] = 1;draw_color_map();}
void BNarc5(GtkButton *button, gpointer data){type[5] = 0; draw_color_map();}
void BNrect5(GtkButton *button, gpointer data){type[5] = 1;draw_color_map();}
void BNarc6(GtkButton *button, gpointer data){type[6] = 0; draw_color_map();}
void BNrect6(GtkButton *button, gpointer data){type[6] = 1;draw_color_map();}
void BNarc7(GtkButton *button, gpointer data){type[7] = 0; draw_color_map();}
void BNrect7(GtkButton *button, gpointer data){type[7] = 1;draw_color_map();}

main(int ac, char **av)
{
    GtkWidget *window;
    GdkVisual *visual;
    GtkWidget *vbox;
    GtkWidget *vbox2;
    GtkWidget *hbox;
    GtkWidget *button;
    GtkWidget *scale;
    GtkWidget *sep;
    GtkWidget *frame;
    GtkWidget *label;
    GtkObject *adj;
    GtkWidget *table;
    GSList *group;
    int i, j;
    int tag;
    FILE *fp;
    int r, g, b;
    char line[1024];

    image_pixel *img;
    image_pixel p;

    hu0[1]=14.0;  hl0[1]=-9.0;  su0[1]=1.0; sl0[1]=0.6; vu0[1]=1.0; vl0[1]=0.8;
    hu0[2]=41.0;  hl0[2]=16.0;  su0[2]=0.9; sl0[2]=0.3; vu0[2]=1.0; vl0[2]=0.8;
    hu0[3]=0.0;   hl0[3]=0.0;   su0[3]=1.0; sl0[3]=0.0; vu0[3]=1.0; vl0[3]=0.8;
    hu0[4]=150.0; hl0[4]=81.0;  su0[4]=0.6; sl0[4]=0.2; vu0[4]=1.0; vl0[4]=0.8;
    hu0[5]=184.0; hl0[5]=116.0; su0[5]=0.5; sl0[5]=0.3; vu0[5]=1.0; vl0[5]=0.8;
    hu0[6]=184.0; hl0[6]=116.0; su0[6]=0.5; sl0[6]=0.3; vu0[6]=1.0; vl0[6]=0.8;
    hu0[7]=184.0; hl0[7]=116.0; su0[7]=0.5; sl0[7]=0.3; vu0[7]=1.0; vl0[7]=0.8;

    for (i = 0; i <= NUM_COLOR; i++){
      hu[i] = hu0[i]; hl[i] = hl0[i];
      su[i] = su0[i]; sl[i] = sl0[i];
      vu[i] = vu0[i]; vl[i] = vl0[i];
      type[i] = 0;
    }

    /* format for boudary parameter file
       Hu(ball) Hl(ball) Su(ball) Sl(ball) Vu(ball) Vl(ball) type(ball)
       Hu(Ymark) Hl(Ymark) Su(Ymark) Sl(Ymark) Vu(Ymark) Vl(Ymark) type(Ymark)
       Hu(Bmark) Hl(Bmark) Su(Bmark) Sl(Bmark) Vu(Bmark) Vl(Bmark) type(Bmark)
       Hu(Ymrk1) Hl(Ymrk1) Su(Ymrk1) Sl(Ymrk1) Vu(Ymrk1) Vl(Ymrk1) type(Ymrk1)
       Hu(Ymrk2) Hl(Ymrk2) Su(Ymrk2) Sl(Ymrk2) Vu(Ymrk2) Vl(Ymrk2) type(Ymrk2)
       Hu(Bmrk1) Hl(Bmrk1) Su(Bmrk1) Sl(Bmrk1) Vu(Bmrk1) Vl(Bmrk1) type(Bmrk1)
       Hu(Bmrk2) Hl(Bmrk2) Su(Bmrk2) Sl(Bmrk2) Vu(Bmrk2) Vl(Bmrk2) type(Bmrk2)
    */
    if (ac > 1){
      fp = fopen(av[1], "r");
      for (i = 1; i <= NUM_COLOR; i++){
	fgets(line, 1023, fp);
	hu[i] = atof(strtok(line, " \t\n"));
	hl[i] = atof(strtok(NULL, " \t\n"));
	su[i] = atof(strtok(NULL, " \t\n"));
	sl[i] = atof(strtok(NULL, " \t\n"));
	vu[i] = atof(strtok(NULL, " \t\n"));
	vl[i] = atof(strtok(NULL, " \t\n"));
	type[i] = atoi(strtok(NULL, " \t\n"));
      }
      fclose(fp);
    }

    dbuf = (unsigned char *)malloc(sizeof(unsigned char) * X*Y*3);
    mapbuf = (unsigned char *)malloc(sizeof(unsigned char) * MAPX*MAPY*3);
    mapbuf0 = (unsigned char *)malloc(sizeof(unsigned char) * MAPX*MAPY*3);
    xs = (int **)malloc(sizeof(int *) * (NUM_COLOR+1));
    ys = (int **)malloc(sizeof(int *) * (NUM_COLOR+1));
    xe = (int **)malloc(sizeof(int *) * (NUM_COLOR+1));
    ye = (int **)malloc(sizeof(int *) * (NUM_COLOR+1));
    no = (int *)malloc(sizeof(int) * (NUM_COLOR+1));
    colr = (int *)malloc(sizeof(int) * (NUM_COLOR+1));
    colg = (int *)malloc(sizeof(int) * (NUM_COLOR+1));
    colb = (int *)malloc(sizeof(int) * (NUM_COLOR+1));
    for (i = 0; i <= NUM_COLOR; i++){
	xs[i] = (int *)malloc(sizeof(int) * NOBJ);
	ys[i] = (int *)malloc(sizeof(int) * NOBJ);
	xe[i] = (int *)malloc(sizeof(int) * NOBJ);
	ye[i] = (int *)malloc(sizeof(int) * NOBJ);
	no[i] = 0;
    }
    colr[CB] = 0xf8; colg[CB] = 0x00; colb[CB] = 0x00;
    colr[CYM] = 0xf8; colg[CYM] = 0xfc; colb[CYM] = 0x00;
    colr[CBM] = 0x00; colg[CBM] = 0x00; colb[CBM] = 0xf8;
    colr[CYM1] = 0x00; colg[CYM1] = 0xfc; colb[CYM1] = 0x00;
    colr[CYM2] = 0xf8; colg[CYM2] = 0x00; colb[CYM2] = 0xf8;
    colr[CBM1] = 0x00; colg[CBM1] = 0xfc; colb[CBM1] = 0xf8;
    colr[CBM2] = 0xf8; colg[CBM2] = 0x80; colb[CBM2] = 0x80;

    BF_OFFSET_PER_LINE = (((X - XE) + XS) * 3);
    if (YS > 0) BF_OFFSET_INIT = (((YS-1)*X) + XS) * 3;
    else BF_OFFSET_INIT = XS * 3;

    if (!cap.initialize("/dev/video", X, Y, V4L2_PIX_FMT_BGR24)){
	fprintf(stderr, "Capture init failed.\n"); exit(1);
    }
    for (i = 0; i < 5; i++) img = (image_pixel*)cap.captureFrame();
    buf_cpy(img);

    update_rect.x = 0; update_rect.y = 0;
    update_rect.width = X; update_rect.height = Y;

    update_rect2.x = 0; update_rect2.y = 0;
    update_rect2.width = MAPX; update_rect2.height = MAPY;
    
    gtk_set_locale ();
    gtk_init(&ac, &av);
    
    window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    
    gtk_window_set_title(GTK_WINDOW(window),
			 "xext : real time color learning system");
    gtk_signal_connect(GTK_OBJECT(window), "destroy",
		       GTK_SIGNAL_FUNC(BNquit), NULL);
    
    vbox = gtk_vbox_new(FALSE, 0);
    gtk_container_add(GTK_CONTAINER(window), vbox);
    
    /* information text */
    label_info1 = gtk_label_new(" ");
    gtk_box_pack_start(GTK_BOX(vbox), label_info1, TRUE, TRUE, 0);
    
    label_info2 = gtk_label_new(" ");
    gtk_box_pack_start(GTK_BOX(vbox), label_info2, TRUE, TRUE, 0);

    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox), hbox ,FALSE, FALSE, 0);
    
    /* image */
    visual = gdk_visual_get_best_with_depth(16);
    if (visual == NULL)
	printf("Error: can't get visual for depth 16\n");

    image = gdk_image_new(GDK_IMAGE_NORMAL, visual, X, Y);
    area = gtk_drawing_area_new();
    gtk_drawing_area_size(GTK_DRAWING_AREA(area), X, Y);
    gtk_box_pack_start(GTK_BOX(hbox), area, TRUE, TRUE, 0);
    (((GdkImagePrivate*)image)->ximage)->data = (char *)dbuf;
    gtk_widget_draw(area, &update_rect);

    gtk_signal_connect(GTK_OBJECT(area), "expose_event",
		       (GtkSignalFunc)EXdraw_image, NULL);

    image2 = gdk_image_new(GDK_IMAGE_NORMAL, visual, MAPX, MAPY);
    area2 = gtk_drawing_area_new();
    gtk_drawing_area_size(GTK_DRAWING_AREA(area2), MAPX, MAPY);
    gtk_box_pack_start(GTK_BOX(hbox), area2, TRUE, TRUE, 0);
    (((GdkImagePrivate*)image2)->ximage)->data = (char *)mapbuf;
    gtk_widget_draw(area2, &update_rect2);

    clear_color_map();
    draw_color_map();

    gtk_signal_connect(GTK_OBJECT(area2), "expose_event",
		       (GtkSignalFunc)EXdraw_image2, NULL);

    gtk_signal_connect(GTK_OBJECT(area), "button_press_event",
		       (GtkSignalFunc)MObutton, NULL);
    gtk_signal_connect(GTK_OBJECT(area), "motion_notify_event",
		       (GtkSignalFunc)MOmoved, NULL);
    
    gtk_widget_set_events(area, GDK_EXPOSURE_MASK
			  | GDK_LEAVE_NOTIFY_MASK
			  | GDK_BUTTON_PRESS_MASK
			  | GDK_POINTER_MOTION_MASK
			  );
    
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox), hbox ,FALSE, FALSE, 0);
    
    label = gtk_label_new("Color:");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    /*
      +-----------------+--------------+
      |                 |              |
      |    image        |  color map   |
      |                 |              |
      +-----------------+--------------+
      [Ball] Y-Mark B-Mark ...
      +--------------------------------+
      |                                |
      |Hu +------------------------+   |
      |Hl +------------------------+   |
      |Su +------------------------+   |
      |Sl +------------------------+   |
      |Vu +------------------------+   |
      |Vl +------------------------+   |
      +--------------------------------+

     */    

    notebook = gtk_notebook_new();
    gtk_notebook_set_tab_pos(GTK_NOTEBOOK(notebook), GTK_POS_TOP);
    gtk_box_pack_start(GTK_BOX(vbox), notebook, FALSE, FALSE, 0);

    /* Ball tab */
    vbox2 = gtk_vbox_new(FALSE, 0);
    label = gtk_label_new("Ball");
    gtk_notebook_append_page(GTK_NOTEBOOK(notebook), vbox2, label);

    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    button = gtk_radio_button_new_with_label (NULL, "Arc");
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(BNarc1), NULL);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(button), TRUE);
    gtk_box_pack_start (GTK_BOX(hbox), button, TRUE, TRUE, 0);
    group = gtk_radio_button_group(GTK_RADIO_BUTTON(button));
    button = gtk_radio_button_new_with_label (group, "Rect");
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(BNrect1), NULL);
    gtk_box_pack_start (GTK_BOX(hbox), button, TRUE, TRUE, 0);

    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("H(U)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjhu1 = gtk_adjustment_new(hu[1], H_ORIGIN,H_ORIGIN+360.0, 0.1, 1.0, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjhu1), "value_changed",
		       GTK_SIGNAL_FUNC(sethu1), adjhu1);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjhu1));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);

    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 0);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("H(L)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjhl1 = gtk_adjustment_new(hl[1], H_ORIGIN,H_ORIGIN+360, 0.1, 1.0, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjhl1), "value_changed",
		       GTK_SIGNAL_FUNC(sethl1), adjhl1);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjhl1));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 0);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("S(U)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjsu1 = gtk_adjustment_new(su[1], 0.0, 1.0, 0.01, 0.1, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjsu1), "value_changed",
		       GTK_SIGNAL_FUNC(setsu1), adjsu1);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjsu1));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 2);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("S(L)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjsl1 = gtk_adjustment_new(sl[1], 0.0, 1.0, 0.01, 0.1, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjsl1), "value_changed",
		       GTK_SIGNAL_FUNC(setsl1), adjsl1);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjsl1));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 2);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("V(U)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjvu1 = gtk_adjustment_new(vu[1], 0.0, 1., 0.01, 0.1, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjvu1), "value_changed",
		       GTK_SIGNAL_FUNC(setvu1), adjvu1);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjvu1));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 2);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("V(L)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjvl1 = gtk_adjustment_new(vl[1], 0.0, 1.0, 0.01, 0.1, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjvl1), "value_changed",
		       GTK_SIGNAL_FUNC(setvl1), adjvl1);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjvl1));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 2);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);

    /* Y-Mark tab */
    vbox2 = gtk_vbox_new(FALSE, 0);
    label = gtk_label_new("Y-Mark");
    gtk_notebook_append_page(GTK_NOTEBOOK(notebook), vbox2, label);

    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    button = gtk_radio_button_new_with_label (NULL, "Arc");
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(BNarc2), NULL);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(button), TRUE);
    gtk_box_pack_start (GTK_BOX(hbox), button, TRUE, TRUE, 0);
    group = gtk_radio_button_group(GTK_RADIO_BUTTON(button));
    button = gtk_radio_button_new_with_label (group, "Rect");
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(BNrect2), NULL);
    gtk_box_pack_start (GTK_BOX(hbox), button, TRUE, TRUE, 0);

    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);

    label = gtk_label_new("H(U)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjhu2 = gtk_adjustment_new(hu[2], H_ORIGIN,H_ORIGIN+360, 0.1, 1.0, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjhu2), "value_changed",
		       GTK_SIGNAL_FUNC(sethu2), adjhu2);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjhu2));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 0);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("H(L)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjhl2 = gtk_adjustment_new(hl[2], H_ORIGIN,H_ORIGIN+360, 0.1, 1.0, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjhl2), "value_changed",
		       GTK_SIGNAL_FUNC(sethl2), adjhl2);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjhl2));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 0);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("S(U)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjsu2 = gtk_adjustment_new(su[2], 0.0, 1.0, 0.01, 0.1, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjsu2), "value_changed",
		       GTK_SIGNAL_FUNC(setsu2), adjsu2);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjsu2));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 2);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("S(L)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjsl2 = gtk_adjustment_new(sl[2], 0.0, 1.0, 0.01, 0.1, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjsl2), "value_changed",
		       GTK_SIGNAL_FUNC(setsl2), adjsl2);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjsl2));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 2);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("V(U)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjvu2 = gtk_adjustment_new(vu[2], 0.0, 1., 0.01, 0.1, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjvu2), "value_changed",
		       GTK_SIGNAL_FUNC(setvu2), adjvu2);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjvu2));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 2);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("V(L)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjvl2 = gtk_adjustment_new(vl[2], 0.0, 1.0, 0.01, 0.1, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjvl2), "value_changed",
		       GTK_SIGNAL_FUNC(setvl2), adjvl2);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjvl2));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 2);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);

    /* B-Mark tab */
    vbox2 = gtk_vbox_new(FALSE, 0);
    label = gtk_label_new("B-Mark");
    gtk_notebook_append_page(GTK_NOTEBOOK(notebook), vbox2, label);

    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    button = gtk_radio_button_new_with_label (NULL, "Arc");
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(BNarc3), NULL);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(button), TRUE);
    gtk_box_pack_start (GTK_BOX(hbox), button, TRUE, TRUE, 0);
    group = gtk_radio_button_group(GTK_RADIO_BUTTON(button));
    button = gtk_radio_button_new_with_label (group, "Rect");
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(BNrect3), NULL);
    gtk_box_pack_start (GTK_BOX(hbox), button, TRUE, TRUE, 0);

    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);

    label = gtk_label_new("H(U)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjhu3 = gtk_adjustment_new(hu[3], H_ORIGIN,H_ORIGIN+360, 0.1, 1.0, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjhu3), "value_changed",
		       GTK_SIGNAL_FUNC(sethu3), adjhu3);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjhu3));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 0);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("H(L)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjhl3 = gtk_adjustment_new(hl[3], H_ORIGIN,H_ORIGIN+360, 0.1, 1.0, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjhl3), "value_changed",
		       GTK_SIGNAL_FUNC(sethl3), adjhl3);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjhl3));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 0);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("S(U)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjsu3 = gtk_adjustment_new(su[3], 0.0, 1.0, 0.01, 0.1, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjsu3), "value_changed",
		       GTK_SIGNAL_FUNC(setsu3), adjsu3);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjsu3));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 2);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("S(L)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjsl3 = gtk_adjustment_new(sl[3], 0.0, 1.0, 0.01, 0.1, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjsl3), "value_changed",
		       GTK_SIGNAL_FUNC(setsl3), adjsl3);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjsl3));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 2);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("V(U)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjvu3 = gtk_adjustment_new(vu[3], 0.0, 1., 0.01, 0.1, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjvu3), "value_changed",
		       GTK_SIGNAL_FUNC(setvu3), adjvu3);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjvu3));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 2);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("V(L)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjvl3 = gtk_adjustment_new(vl[3], 0.0, 1.0, 0.01, 0.1, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjvl3), "value_changed",
		       GTK_SIGNAL_FUNC(setvl3), adjvl3);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjvl3));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 2);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);

    /* Y-Mark1 tab */
    vbox2 = gtk_vbox_new(FALSE, 0);
    label = gtk_label_new("Y-Mark1");
    gtk_notebook_append_page(GTK_NOTEBOOK(notebook), vbox2, label);

    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    button = gtk_radio_button_new_with_label (NULL, "Arc");
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(BNarc4), NULL);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(button), TRUE);
    gtk_box_pack_start (GTK_BOX(hbox), button, TRUE, TRUE, 0);
    group = gtk_radio_button_group(GTK_RADIO_BUTTON(button));
    button = gtk_radio_button_new_with_label (group, "Rect");
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(BNrect4), NULL);
    gtk_box_pack_start (GTK_BOX(hbox), button, TRUE, TRUE, 0);

    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);

    label = gtk_label_new("H(U)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjhu4 = gtk_adjustment_new(hu[4], H_ORIGIN,H_ORIGIN+360, 0.1, 1.0, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjhu4), "value_changed",
		       GTK_SIGNAL_FUNC(sethu4), adjhu4);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjhu4));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 0);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("H(L)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjhl4 = gtk_adjustment_new(hl[4], H_ORIGIN,H_ORIGIN+360, 0.1, 1.0, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjhl4), "value_changed",
		       GTK_SIGNAL_FUNC(sethl4), adjhl4);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjhl4));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 0);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("S(U)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjsu4 = gtk_adjustment_new(su[4], 0.0, 1.0, 0.01, 0.1, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjsu4), "value_changed",
		       GTK_SIGNAL_FUNC(setsu4), adjsu4);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjsu4));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 2);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("S(L)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjsl4 = gtk_adjustment_new(sl[4], 0.0, 1.0, 0.01, 0.1, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjsl4), "value_changed",
		       GTK_SIGNAL_FUNC(setsl4), adjsl4);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjsl4));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 2);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("V(U)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjvu4 = gtk_adjustment_new(vu[4], 0.0, 1., 0.01, 0.1, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjvu4), "value_changed",
		       GTK_SIGNAL_FUNC(setvu4), adjvu4);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjvu4));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 2);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("V(L)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjvl4 = gtk_adjustment_new(vl[4], 0.0, 1.0, 0.01, 0.1, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjvl4), "value_changed",
		       GTK_SIGNAL_FUNC(setvl4), adjvl4);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjvl4));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 2);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);

    /* Y-Mark2 tab */
    vbox2 = gtk_vbox_new(FALSE, 0);
    label = gtk_label_new("Y-Mark2");
    gtk_notebook_append_page(GTK_NOTEBOOK(notebook), vbox2, label);

    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    button = gtk_radio_button_new_with_label (NULL, "Arc");
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(BNarc5), NULL);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(button), TRUE);
    gtk_box_pack_start (GTK_BOX(hbox), button, TRUE, TRUE, 0);
    group = gtk_radio_button_group(GTK_RADIO_BUTTON(button));
    button = gtk_radio_button_new_with_label (group, "Rect");
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(BNrect5), NULL);
    gtk_box_pack_start (GTK_BOX(hbox), button, TRUE, TRUE, 0);

    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);

    label = gtk_label_new("H(U)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjhu5 = gtk_adjustment_new(hu[5], H_ORIGIN,H_ORIGIN+360, 0.1, 1.0, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjhu5), "value_changed",
		       GTK_SIGNAL_FUNC(sethu5), adjhu5);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjhu5));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 0);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("H(L)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjhl5 = gtk_adjustment_new(hl[5], H_ORIGIN,H_ORIGIN+360, 0.1, 1.0, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjhl5), "value_changed",
		       GTK_SIGNAL_FUNC(sethl5), adjhl5);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjhl5));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 0);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("S(U)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjsu5 = gtk_adjustment_new(su[5], 0.0, 1.0, 0.01, 0.1, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjsu5), "value_changed",
		       GTK_SIGNAL_FUNC(setsu5), adjsu5);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjsu5));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 2);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("S(L)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjsl5 = gtk_adjustment_new(sl[5], 0.0, 1.0, 0.01, 0.1, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjsl5), "value_changed",
		       GTK_SIGNAL_FUNC(setsl5), adjsl5);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjsl5));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 2);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("V(U)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjvu5 = gtk_adjustment_new(vu[5], 0.0, 1., 0.01, 0.1, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjvu5), "value_changed",
		       GTK_SIGNAL_FUNC(setvu5), adjvu5);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjvu5));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 2);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("V(L)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjvl5 = gtk_adjustment_new(vl[5], 0.0, 1.0, 0.01, 0.1, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjvl5), "value_changed",
		       GTK_SIGNAL_FUNC(setvl5), adjvl5);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjvl5));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 2);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);

    gtk_signal_connect(GTK_OBJECT(notebook), "switch-page",
		       GTK_SIGNAL_FUNC(NBchange), NULL);
    gtk_notebook_set_page(GTK_NOTEBOOK(notebook), 1);

    /* B-Mark1 tab */
    vbox2 = gtk_vbox_new(FALSE, 0);
    label = gtk_label_new("B-Mark1");
    gtk_notebook_append_page(GTK_NOTEBOOK(notebook), vbox2, label);

    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    button = gtk_radio_button_new_with_label (NULL, "Arc");
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(BNarc6), NULL);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(button), TRUE);
    gtk_box_pack_start (GTK_BOX(hbox), button, TRUE, TRUE, 0);
    group = gtk_radio_button_group(GTK_RADIO_BUTTON(button));
    button = gtk_radio_button_new_with_label (group, "Rect");
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(BNrect6), NULL);
    gtk_box_pack_start (GTK_BOX(hbox), button, TRUE, TRUE, 0);

    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);

    label = gtk_label_new("H(U)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjhu6 = gtk_adjustment_new(hu[6], H_ORIGIN,H_ORIGIN+360, 0.1, 1.0, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjhu6), "value_changed",
		       GTK_SIGNAL_FUNC(sethu6), adjhu6);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjhu6));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 0);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("H(L)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjhl6 = gtk_adjustment_new(hl[6], H_ORIGIN,H_ORIGIN+360, 0.1, 1.0, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjhl6), "value_changed",
		       GTK_SIGNAL_FUNC(sethl6), adjhl6);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjhl6));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 0);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("S(U)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjsu6 = gtk_adjustment_new(su[6], 0.0, 1.0, 0.01, 0.1, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjsu6), "value_changed",
		       GTK_SIGNAL_FUNC(setsu6), adjsu6);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjsu6));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 2);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("S(L)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjsl6 = gtk_adjustment_new(sl[6], 0.0, 1.0, 0.01, 0.1, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjsl6), "value_changed",
		       GTK_SIGNAL_FUNC(setsl6), adjsl6);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjsl6));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 2);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("V(U)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjvu6 = gtk_adjustment_new(vu[6], 0.0, 1., 0.01, 0.1, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjvu6), "value_changed",
		       GTK_SIGNAL_FUNC(setvu6), adjvu6);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjvu6));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 2);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("V(L)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjvl6 = gtk_adjustment_new(vl[6], 0.0, 1.0, 0.01, 0.1, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjvl6), "value_changed",
		       GTK_SIGNAL_FUNC(setvl6), adjvl6);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjvl6));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 2);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);

    /* B-Mark2 tab */
    vbox2 = gtk_vbox_new(FALSE, 0);
    label = gtk_label_new("B-Mark2");
    gtk_notebook_append_page(GTK_NOTEBOOK(notebook), vbox2, label);

    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    button = gtk_radio_button_new_with_label (NULL, "Arc");
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(BNarc7), NULL);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(button), TRUE);
    gtk_box_pack_start (GTK_BOX(hbox), button, TRUE, TRUE, 0);
    group = gtk_radio_button_group(GTK_RADIO_BUTTON(button));
    button = gtk_radio_button_new_with_label (group, "Rect");
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(BNrect7), NULL);
    gtk_box_pack_start (GTK_BOX(hbox), button, TRUE, TRUE, 0);

    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);

    label = gtk_label_new("H(U)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjhu7 = gtk_adjustment_new(hu[7], H_ORIGIN,H_ORIGIN+360, 0.1, 1.0, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjhu7), "value_changed",
		       GTK_SIGNAL_FUNC(sethu7), adjhu7);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjhu7));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 0);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("H(L)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjhl7 = gtk_adjustment_new(hl[7], H_ORIGIN,H_ORIGIN+360, 0.1, 1.0, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjhl7), "value_changed",
		       GTK_SIGNAL_FUNC(sethl7), adjhl7);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjhl7));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 0);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("S(U)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjsu7 = gtk_adjustment_new(su[7], 0.0, 1.0, 0.01, 0.1, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjsu7), "value_changed",
		       GTK_SIGNAL_FUNC(setsu7), adjsu7);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjsu7));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 2);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("S(L)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjsl7 = gtk_adjustment_new(sl[7], 0.0, 1.0, 0.01, 0.1, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjsl7), "value_changed",
		       GTK_SIGNAL_FUNC(setsl7), adjsl7);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjsl7));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 2);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("V(U)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjvu7 = gtk_adjustment_new(vu[7], 0.0, 1., 0.01, 0.1, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjvu7), "value_changed",
		       GTK_SIGNAL_FUNC(setvu7), adjvu7);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjvu7));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 2);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox2), hbox ,FALSE, FALSE, 0);
    label = gtk_label_new("V(L)");
    gtk_box_pack_start(GTK_BOX(hbox), label, TRUE, TRUE, 0);
    adjvl7 = gtk_adjustment_new(vl[7], 0.0, 1.0, 0.01, 0.1, 0.0);
    gtk_signal_connect(GTK_OBJECT(adjvl7), "value_changed",
		       GTK_SIGNAL_FUNC(setvl7), adjvl7);
    scale = gtk_hscale_new(GTK_ADJUSTMENT(adjvl7));
    gtk_widget_set_usize(GTK_WIDGET(scale), 300, 30);
    gtk_range_set_update_policy(GTK_RANGE(scale), ADJ_UPDATE);
    gtk_scale_set_digits(GTK_SCALE(scale), 2);
    gtk_scale_set_draw_value(GTK_SCALE(scale), TRUE);
    gtk_box_pack_start(GTK_BOX(hbox), scale ,TRUE, TRUE, 0);

    gtk_signal_connect(GTK_OBJECT(notebook), "switch-page",
		       GTK_SIGNAL_FUNC(NBchange), NULL);
    gtk_notebook_set_page(GTK_NOTEBOOK(notebook), 1);


    /* View */
    button = gtk_button_new_with_label("View");
    gtk_box_pack_start(GTK_BOX(vbox), button ,TRUE, TRUE, 0);
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(BNview), NULL);
    
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox), hbox ,FALSE, FALSE, 0);
    
    /* Redraw */
    button = gtk_button_new_with_label("Redraw");
    gtk_box_pack_start(GTK_BOX(hbox), button ,TRUE, TRUE, 0);
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(BNredraw), NULL);
    
    /* Confirm */
    button = gtk_button_new_with_label("Confirm");
    gtk_box_pack_start(GTK_BOX(hbox), button ,TRUE, TRUE, 0);
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(BNconfirm), NULL);
    
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox), hbox ,FALSE, FALSE, 0);
    
    /* Start */
    button = gtk_button_new_with_label("Start");
    gtk_box_pack_start(GTK_BOX(hbox), button ,TRUE, TRUE, 0);
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(BNstart), NULL);
    /* Stop */
    button = gtk_button_new_with_label("Stop");
    gtk_box_pack_start(GTK_BOX(hbox), button ,TRUE, TRUE, 0);
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(BNstop), NULL);
    /* Clear */
    button = gtk_button_new_with_label("Clear");
    gtk_box_pack_start(GTK_BOX(hbox), button ,TRUE, TRUE, 0);
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(BNclear), NULL);
    
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox), hbox ,FALSE, FALSE, 0);
    
    /* Extract */
    button = gtk_button_new_with_label("Extract");
    gtk_box_pack_start(GTK_BOX(hbox), button ,TRUE, TRUE, 0);
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(BNextract), NULL);
    
    /* Extract All */
    button = gtk_button_new_with_label("ExtractAll");
    gtk_box_pack_start(GTK_BOX(hbox), button ,TRUE, TRUE, 0);
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(BNextract_all), NULL);
    
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_box_pack_start(GTK_BOX(vbox), hbox ,FALSE, FALSE, 0);
    
    /* Save Color */
    button = gtk_button_new_with_label("Save Color");
    gtk_box_pack_start(GTK_BOX(hbox), button ,TRUE, TRUE, 0);
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(BNsave_color), NULL);
    /* Quit */
    button = gtk_button_new_with_label("Quit");
    gtk_box_pack_start(GTK_BOX(hbox), button ,TRUE, TRUE, 0);
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(BNquit), NULL);
    
    tag = gtk_timeout_add(TCYCLE, (GtkFunction)timer_call, window);
    
    gtk_widget_show_all(window);

    gtk_main();
    
    gtk_timeout_remove(tag);
}
